extern const LV2_Descriptor* lv2_descriptor(uint32_t index);
extern const LV2UI_Descriptor* lv2ui_descriptor(uint32_t index);

static const RtkLv2Description _plugin = {
	&lv2_descriptor, &lv2ui_descriptor
	, 0 // uint32_t dsp_descriptor_id
	, 0 // uint32_t gui_descriptor_id
	, "Matrix Mixer 8x8"
	, (const struct LV2Port[80])
	{
		{ "in1", AUDIO_IN, nan, nan, nan, "Audio Input 1"},
		{ "in2", AUDIO_IN, nan, nan, nan, "Audio Input 2"},
		{ "in3", AUDIO_IN, nan, nan, nan, "Audio Input 3"},
		{ "in4", AUDIO_IN, nan, nan, nan, "Audio Input 4"},
		{ "in5", AUDIO_IN, nan, nan, nan, "Audio Input 5"},
		{ "in6", AUDIO_IN, nan, nan, nan, "Audio Input 6"},
		{ "in7", AUDIO_IN, nan, nan, nan, "Audio Input 7"},
		{ "in8", AUDIO_IN, nan, nan, nan, "Audio Input 8"},
		{ "out1", AUDIO_OUT, nan, nan, nan, "Audio Output 1"},
		{ "out2", AUDIO_OUT, nan, nan, nan, "Audio Output 2"},
		{ "out3", AUDIO_OUT, nan, nan, nan, "Audio Output 3"},
		{ "out4", AUDIO_OUT, nan, nan, nan, "Audio Output 4"},
		{ "out5", AUDIO_OUT, nan, nan, nan, "Audio Output 5"},
		{ "out6", AUDIO_OUT, nan, nan, nan, "Audio Output 6"},
		{ "out7", AUDIO_OUT, nan, nan, nan, "Audio Output 7"},
		{ "out8", AUDIO_OUT, nan, nan, nan, "Audio Output 8"},
		{ "mix_1_1", CONTROL_IN, 1.f, -6.f, 6.f,"Mix 1 1"},
		{ "mix_1_2", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 1 2"},
		{ "mix_1_3", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 1 3"},
		{ "mix_1_4", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 1 4"},
		{ "mix_1_5", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 1 5"},
		{ "mix_1_6", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 1 6"},
		{ "mix_1_7", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 1 7"},
		{ "mix_1_8", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 1 8"},
		{ "mix_2_1", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 2 1"},
		{ "mix_2_2", CONTROL_IN, 1.f, -6.f, 6.f,"Mix 2 2"},
		{ "mix_2_3", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 2 3"},
		{ "mix_2_4", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 2 4"},
		{ "mix_2_5", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 2 5"},
		{ "mix_2_6", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 2 6"},
		{ "mix_2_7", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 2 7"},
		{ "mix_2_8", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 2 8"},
		{ "mix_3_1", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 3 1"},
		{ "mix_3_2", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 3 2"},
		{ "mix_3_3", CONTROL_IN, 1.f, -6.f, 6.f,"Mix 3 3"},
		{ "mix_3_4", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 3 4"},
		{ "mix_3_5", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 3 5"},
		{ "mix_3_6", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 3 6"},
		{ "mix_3_7", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 3 7"},
		{ "mix_3_8", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 3 8"},
		{ "mix_4_1", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 4 1"},
		{ "mix_4_2", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 4 2"},
		{ "mix_4_3", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 4 3"},
		{ "mix_4_4", CONTROL_IN, 1.f, -6.f, 6.f,"Mix 4 4"},
		{ "mix_4_5", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 4 5"},
		{ "mix_4_6", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 4 6"},
		{ "mix_4_7", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 4 7"},
		{ "mix_4_8", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 4 8"},
		{ "mix_5_1", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 5 1"},
		{ "mix_5_2", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 5 2"},
		{ "mix_5_3", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 5 3"},
		{ "mix_5_4", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 5 4"},
		{ "mix_5_5", CONTROL_IN, 1.f, -6.f, 6.f,"Mix 5 5"},
		{ "mix_5_6", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 5 6"},
		{ "mix_5_7", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 5 7"},
		{ "mix_5_8", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 5 8"},
		{ "mix_6_1", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 6 1"},
		{ "mix_6_2", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 6 2"},
		{ "mix_6_3", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 6 3"},
		{ "mix_6_4", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 6 4"},
		{ "mix_6_5", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 6 5"},
		{ "mix_6_6", CONTROL_IN, 1.f, -6.f, 6.f,"Mix 6 6"},
		{ "mix_6_7", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 6 7"},
		{ "mix_6_8", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 6 8"},
		{ "mix_7_1", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 7 1"},
		{ "mix_7_2", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 7 2"},
		{ "mix_7_3", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 7 3"},
		{ "mix_7_4", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 7 4"},
		{ "mix_7_5", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 7 5"},
		{ "mix_7_6", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 7 6"},
		{ "mix_7_7", CONTROL_IN, 1.f, -6.f, 6.f,"Mix 7 7"},
		{ "mix_7_8", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 7 8"},
		{ "mix_8_1", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 8 1"},
		{ "mix_8_2", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 8 2"},
		{ "mix_8_3", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 8 3"},
		{ "mix_8_4", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 8 4"},
		{ "mix_8_5", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 8 5"},
		{ "mix_8_6", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 8 6"},
		{ "mix_8_7", CONTROL_IN, 0.f, -6.f, 6.f,"Mix 8 7"},
		{ "mix_8_8", CONTROL_IN, 1.f, -6.f, 6.f,"Mix 8 8"},
	}
	, 80 // uint32_t nports_total
	, 8 // uint32_t nports_audio_in
	, 8 // uint32_t nports_audio_out
	, 0 // uint32_t nports_midi_in
	, 0 // uint32_t nports_midi_out
	, 0 // uint32_t nports_atom_in
	, 0 // uint32_t nports_atom_out
	, 64 // uint32_t nports_ctrl
	, 64 // uint32_t nports_ctrl_in
	, 0 // uint32_t nports_ctrl_out
	, 8192 // uint32_t min_atom_bufsiz
	, false // bool send_time_info
	, UINT32_MAX // uint32_t latency_ctrl_port
};

